#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

int searching;
int sons_quit;

int sudoku[64];
int n;
int c;

void sig_handler(int s) {
  switch(s) {
  case SIGUSR1:
	 printf("Papa received SIGUSR1\n");
	 searching = 0;
	 kill(0, SIGUSR2);
	 break;
  case SIGUSR2:
	 printf("Papa received SIGUSR2\n");
	 ++sons_quit;
	 if (sons_quit == 8) {
		sudoku[c] = 0;
		--n;
		searching = 0;
		printf("Papa pruned case %u\n", c);
	 }
	 break;
  }
}

int find_free_case(int t[64]) {
  int i;

  for (i=0; i < 64; ++i) {
	 if (t[i]) return i;
  }

  return -1;
}

int main(void) {
  int r;
  int i;
  char tmp[10];
  char *args[] = { "sudok_fils", tmp, NULL };

  memset(sudoku, 1, 64);
  n = 64;
  srand(time(NULL));

  signal(SIGUSR1, sig_handler);
  signal(SIGUSR2, sig_handler);

  while (n > 60) {
	 printf("Free case left: %u\n", n);
	 c = find_free_case(sudoku);
	 r = rand()%9 + 1;
	 searching = 1;
	 sons_quit = 0;
	 for (i=1; i < 10; ++i) {
		if (i != r) {
		  if(!fork()) {
			 sprintf(tmp, "%u", i);
			 execv(args[0], args);
		  }
		}
	 }
	 while (searching) {
		pause();
	 }
  }
  
  return 0;
}
